#!/usr/bin/env python

import argparse
import os
import numpy as np
import iio

np.warnings.filterwarnings('ignore')

parser = argparse.ArgumentParser()
parser.add_argument('pre', type=str, help=('path to the pre processed file (tiff)'))
parser.add_argument('model', type=str, help=('path to model file (tiff)'))
parser.add_argument('res', type=str, help=('path to residual file (tiff)'))
args = parser.parse_args()

pre = iio.read(args.pre)
model = iio.read(args.model)
res = iio.read(args.res)

mini = np.percentile(pre, 5, axis=(0,1), keepdims=True)
maxi = np.percentile(pre, 99, axis=(0,1), keepdims=True)
pre = (pre-mini)/(maxi-mini)*255
model = (model-mini)/(maxi-mini)*255

res = np.abs(res)
mini = np.percentile(res, 5, axis=(0,1), keepdims=True)
maxi = np.percentile(res, 99, axis=(0,1), keepdims=True)
res = (res-mini)/(maxi-mini)*255

for i in range(pre.shape[2]):
    iio.write(args.pre[:-5] + '_channel_' + str(i) + '.png', pre[:,:,i])
    iio.write(args.model[:-5] + '_channel_' + str(i) + '.png', model[:,:,i])
    iio.write(args.res[:-5] + '_channel_' + str(i) + '.png', res[:,:,i])
