#!/usr/bin/env python

import argparse
import os
import numpy as np
import iio

np.warnings.filterwarnings('ignore')

parser = argparse.ArgumentParser()
parser.add_argument('input', type=str, help=('path to source (tiff)'))
parser.add_argument('output', type=str, help=('path to output (tiff)'))
parser.add_argument('dims', type=int, help=('remove first dims'))
args = parser.parse_args()

img = iio.read(args.input)
cropped = img[:,:,args.dims:]

iio.write(args.output, cropped)
