#!/usr/bin/env python

import argparse
import os
import numpy as np
import iio

np.warnings.filterwarnings('ignore')

parser = argparse.ArgumentParser()
parser.add_argument('input', type=str, help=('path to source (tiff)'))
parser.add_argument('output', type=str, help=('path to output (tiff)'))
parser.add_argument('lognfa', type=float, help=('log nfa'))
args = parser.parse_args()

img = iio.read(args.input)

# Compute the center
mu = np.mean(img, axis=(0,1))
print(mu.shape)
img = img - mu
var = np.var(img, axis=(0,1))
img = np.square(img)/var
img = np.sqrt(np.sum(img, axis=2))

# Do the thresholding based on the nfa
N = img.shape[0] * img.shape[1]
thresh = 0.5 * (np.log(2*N) - args.lognfa)
detection = (np.log(img) > thresh) * 255
iio.write(args.output, detection)
