#!/usr/bin/env python

import argparse
import os
import numpy as np
import iio

np.warnings.filterwarnings('ignore')

parser = argparse.ArgumentParser()
parser.add_argument('input', type=str, help=('path to source (tiff)'))
parser.add_argument('output', type=str, help=('path to output (tiff or png)'))
parser.add_argument('pixelNFA', type=str, help=('path to pixelNFA'))
parser.add_argument('detection', type=str, help=('path to output detection mask'))
parser.add_argument('nfa', type=float, help=('nfa threshold'))
args = parser.parse_args()

img = iio.read(args.input)
out = np.zeros((img.shape[0], img.shape[1], max(3, img.shape[2])))


mini = np.percentile(img, 5, axis=(0,1,2), keepdims=True)
maxi = np.percentile(img, 99, axis=(0,1,2), keepdims=True)
out[:,:,:img.shape[2]] = (img-mini)/(maxi-mini)*255

iio.write(args.output, out[:,:,:3])

pxlnfa = iio.read(args.pixelNFA)
detection = (pxlnfa < args.nfa) * 255
iio.write(args.detection, detection)
